﻿package
{ 
	import flash.display.Sprite;	

	public class PixelGrid extends Sprite
	{
		//variables
		private var pixelArr:Array;
		//private var border:Shape;
		public var dimX:uint;
		public var dimY:uint;
		
		public function PixelGrid($str:String)
		{		
			var stArr:Array = $str.split("#");
			
			dimX = uint(stArr[0]);
			dimY = uint(stArr[1]);
			var pixStr:String = stArr[2];
		
			//border = new Shape();
			//border.graphics.lineStyle(3);
			//border.graphics.drawRect(-$x*Constants.PIXDIM_CANVAS/2, -$y*Constants.PIXDIM_CANVAS/2, $x*Constants.PIXDIM_CANVAS, $y*Constants.PIXDIM_CANVAS);
			//addChild(border);
		
			pixelArr = [];
		    for(var yy:uint=0; yy<dimY; yy++){
				pixelArr[yy] = [];
				for(var xx:uint=0; xx<dimX; xx++){
					pixelArr[yy][xx] = new Square(charToColor(pixStr.charAt(0)));
					pixStr = pixStr.substr(1);
					pixelArr[yy][xx].x = xx*Constants.PIXDIM;
					pixelArr[yy][xx].y = yy*Constants.PIXDIM;		
					if((pixelArr[yy][xx].col != Constants.COLEMPTYPIXEL) || Constants.DEBUGMODE) addChild(pixelArr[yy][xx]);
				}
			}
		}
		
		public function pixToString():String
		{
			var outStr:String;
			outStr = String(dimX) + "#" + String(dimY) + "#" ;
			
			for(var yy:uint=0; yy<dimY; yy++){
				for(var xx:uint=0; xx<dimX; xx++){
					switch (pixelArr[xx][yy].col) {
						case Constants.COL1: outStr+="1"; break;
						case Constants.COL2: outStr+="2"; break;
						case Constants.COL3: outStr+="3"; break;
						case Constants.COL4: outStr+="4"; break;
						case Constants.COL5: outStr+="5"; break;
						case Constants.COL6: outStr+="6"; break;
						case Constants.COL7: outStr+="7"; break;
						case Constants.COL8: outStr+="8"; break;
					}
				}
			}
					return outStr;
		}
		
		private function charToColor($char:String):uint
		{
			switch($char) {
				case "1": return Constants.COL1;
				case "2": return Constants.COL2;
				case "3": return Constants.COL3;
				case "4": return Constants.COL4;
				case "5": return Constants.COL5;
				case "6": return Constants.COL6;
				case "7": return Constants.COL7;
				case "8": return Constants.COL8;
				default: return null;
			}
		}
		
	}
}